﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.3
@EndOfDesignText@
'Custom View class 
#Event: Click ()
Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mBase As Panel
	Private Const DefaultColorConstant As Int = -984833 'ignore
	
	Private mButton As Button
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
End Sub

Public Sub DesignerCreateView (Base As Panel, Lbl As Label, Props As Map)
	mBase = Base

	mButton.Initialize("mButton")
	Base.AddView(mButton, 0, 0, Base.Width, Base.Height)
	mButton.Background = Base.Background
	
	mButton.Text = Lbl.Text
	mButton.TextSize = Lbl.TextSize
End Sub

Public Sub GetBase As Panel
	Return mBase
End Sub

Private Sub mButton_Click
	Dim Duration As Int = 50
	Dim Offset As Float = 1.05
	Wait For (Animation (mBase, Duration, mBase.Left * Offset, mBase.Top * Offset)) Complete (Dummy As Boolean)
	Wait For (Animation (mBase, Duration, mBase.Left / Offset, mBase.Top / Offset)) Complete (Dummy As Boolean)
	CallSub(mCallBack, mEventName & "_Click")
End Sub

private Sub Animation (VW As View, duration As Long, X As Int, Y As Int) As ResumableSub
	VW.SetLayoutAnimated(duration, X, Y, VW.width, VW.Height)
	Sleep(duration)
	Return True
End Sub